(* $Id: ast.mli,v 1.1 2011-11-03 13:26:30 deraugla Exp $ *)

type scenario =
  { tasks_def : array task_def;
    algorithm : algorithm;
    constraints : constraints }
and task_def =
  { release : int; duration : int; sub_duration : list sub_duration;
    deadline : int; period : int; user_release : int; non_preemptive : bool;
    strict_per : bool; pree_cost : int }
and constraints = 
  { global_precedence : bool;
    graph_precedence : list (list int);
    preemption_cost : int }
and sub_duration =
  { sub_rel : int; sub_dur : int; sub_non_pree : bool; sub_str_per : bool }
and latency_constr =
  { l_task1 : int; l_inst1 : int; l_task2 : int; l_inst2 : int; l_max : int }
and algorithm =
  [ AL_deadline_monotonic
  | AL_rate_monotonic
  | AL_edf
  | AL_audsley of audsley_info
  | AL_user of array int ]
and audsley_info =
  { ai_pos : position;
    ai_tab : array int;
    ai_step : int;
    ai_nsol : int }
and position =
  [ P_begin
  | P_middle
  | P_end ]
;

type alt 'a 'b = [ Left of 'a | Right of 'b ];
