(* $Id: dim.ml,v 1.1 2010-11-05 03:02:06 deraugla Exp $ *)

open Dim_def;
open Dtasks;

value x_center_of_width one_lcm width =
  width * 9 / 20
;
value y_center_of_height one_lcm height =
  height / 2
;
value radius_of_width_height one_lcm width height =
  min (height * 3 / 10) (width / 4)
;

value dim_of_width_height ts dam_width dam_height =
  let one_lcm = ts.rmax = 0 in
  let x_center = x_center_of_width one_lcm dam_width in
  let y_center = y_center_of_height one_lcm dam_height in
  let radius = radius_of_width_height one_lcm dam_width dam_height in
  {dam_width = dam_width; dam_height = dam_height;
   x_center = x_center; y_center = y_center; radius = radius;
   dam_bb_x = x_center - radius; dam_bb_y = y_center - radius;
   dam_bb_width = 2 * radius; dam_bb_height = 2 * radius}
;

value schedule_height ntask = 40 * ntask + 70;
value many_tasks task = (*False &&*) Array.length task >= 7;
