(* $Id: draw_dameid.mli,v 1.28 2010-11-25 09:02:42 deraugla Exp $ *)

open Glob_glob;

value pi : float;
value round : float → int;
value grand_tour : int;
value quarter_tour : int;
value disp_lim : int;
value xy_of_rad_grad : int → (int * int * float) → (int * int);
value visible_angles : int → int → int → int → (int * int);
value task_color : scenario_gen _ -> int -> int;

value draw_sector :
  Glob_glob.gfun α β γ δ ε → Glob_glob.scenario_gen ζ → β →
    γ → Glob_glob.zoom η → int → unit;
value draw_sectors :
  Glob_glob.gfun α β γ δ ε → Glob_glob.scenario_gen ζ → α →
    β → γ → Glob_glob.zoom η → unit;

value draw_orient :
  Glob_glob.gfun α β γ δ ε → Glob_glob.scenario_gen α → β →
    γ → bool → unit;
value draw_skeleton :
  Glob_glob.gfun α β γ δ ε → Glob_glob.scenario_gen α → β →
    γ → Glob_glob.zoom ζ → unit;

value draw_latencies :
  Glob_glob.gfun α β γ δ ε → Glob_glob.scenario_gen α → β →
    γ → ζ → bool → unit;
value draw_caption :
  Glob_glob.gfun α β γ δ ε → Glob_glob.scenario_gen α → β →
    γ → unit;
