(* $Id: draw_dameid_rt.ml,v 1.36 2010-12-04 07:06:11 deraugla Exp $ *)

open Da;
open Data_rt;
open Dim_def;
open Glob_glob;

type drawable = (Da.da_data * string * Rt.widget);

value dameid_drawable_of_zoom wid dd =
  fun
  [ Zoom _ wid _ _ -> (dd, "dameid_zoom", wid)
  | NoZoom -> (dd, "dameid", wid) ]
;

value caption_drawable wid dd = (dd, "caption", wid);

value min_zoom_dx sc zi =
  let dim = sc.graph.dd.rt_dim in
  zi.zi_n * (dim.dam_bb_x - zi.zi_x)
;
value max_zoom_dx sc zi =
  let dim = sc.graph.dd.rt_dim in
  zi.zi_n * (dim.dam_bb_x + dim.dam_bb_width - zi.zi_x)
;
value min_zoom_dy sc zi =
  let dim = sc.graph.dd.rt_dim in
  zi.zi_n * (dim.dam_bb_y - zi.zi_y)
;
value max_zoom_dy sc zi =
  let dim = sc.graph.dd.rt_dim in
  zi.zi_n * (dim.dam_bb_y + dim.dam_bb_height - zi.zi_y)
;
