(* $Id: draw_schedule_rt.ml,v 1.26 2010-12-04 07:06:11 deraugla Exp $ *)

open Ast;
open Da;
open Data_rt;
open Dtasks;
open Glob_glob;

(* *)

value min_zoom_dx gd zi = zi.zi_n * (Draw_schedule.left_sched - zi.zi_x);
value max_zoom_dx gd zi =
  zi.zi_n * (Draw_schedule.right_sched gd.graph.dd.sched_width - zi.zi_x)
;
value min_zoom_dy gd zi = gd.graph.dd.inter_task_dy - zi.zi_y;
value max_zoom_dy gd zi =
  gd.graph.dd.inter_task_dy * (Array.length gd.ts.ast.tasks_def) - zi.zi_y
;

(* Draw schedule *)

type drawable = (Da.da_data * string * Rt.widget);

(*
value drawable_of_zoom name wid graph =
  fun
  [ Zoom _ wid _ _ _ _ _ -> (graph.dd, name ^ "_zoom", wid)
  | NoZoom -> (graph.dd, name, wid) ]
;
*)

value schedule_drawable_of_zoom wid dd =
  fun
  [ Zoom _ wid _ _ -> (dd, "sched_zoom", wid)
  | NoZoom -> (dd, "sched", wid) ]
;

value mesoid_drawable wid dd = (dd, "mesoid", wid);

value expose_schedule gfun tg isc sched_wid = do {
  let sc = tg.scenario.(isc) in
  let drw = schedule_drawable_of_zoom sched_wid sc.graph.dd NoZoom in
  let gc = ref DaNonePn in
  Draw_schedule.draw_schedule gfun sc drw gc
};
