(* $Id: dtasks.mli,v 1.7 2010-11-28 10:42:32 deraugla Exp $ *)

type tasks =
  { ast : mutable Ast.scenario;
    task_order : mutable array int;
    user_graph_precedence : mutable list (list int);
    strict_periodicity : mutable bool;
    fully_non_preemptive : mutable bool;
    latency_constr : mutable list latency;
    schedule_len : mutable int;

    disp_schedule : mutable Sarray.t (option time_unit);
    comp_schedule : mutable Sarray.t (option time_unit);
    rmax : mutable int;
    lcm : mutable int;
    min_rel_time : mutable int;

    schedule_status : mutable schedule_status;
    repetition : mutable option (int * int);
    curr_ord_ind : mutable int;
    curr_inst : mutable int;
    curr_step : mutable int;
    do_refresh : mutable bool }
and time_unit =
  { u_task : int; u_inst : int; u_preempt : bool }
and latency =
  { l_constr : mutable Ast.latency_constr;
    l_status : mutable latency_status }
and schedule_status =
  [ SS_running
  | SS_schedulable_but of string
  | SS_task_error of int and string
  | SS_incomplete_scheduling of int and string
  | SS_several_lcm of int ]
and latency_status =
  [ LS_unchecked
  | LS_out_of_bounds
  | LS_invalid
  | LS_values of (int * int) and (int * int) and int ]
;
