(* $Id: dutil.ml,v 1.27 2011-03-15 09:42:22 deraugla Exp $ *)

open Printf;
open Rt;

open Da;
open Data_rt;
open Glob_glob;

value task_color sc itask =
  let i =
    loop 0 where rec loop i =
      if sc.initial_order.(i) = itask then i
      else loop (i + 1)
  in
  sc.graph.color.(i mod Array.length sc.graph.color)
;

value g_widget_named gd s =
  let isc = gd.ind_of_isc.(gd.curr_sc) in
  Rt.widget_named gd.common.xd (sprintf "%s_%d" s isc)
;

value redirect_to_main gd = do {
  Rt.rt_redirect_key_press_to (Rt.widget_named gd.common.xd "main");
  for i = 0 to Array.length gd.scenario - 1 do {
    let sc = gd.scenario.(i) in
    List.iter (fun (_, wid, _) -> Rt.rt_dont_redirect_key_press_from wid)
      sc.graph.zooms_sch;
    List.iter (fun (_, wid, _) -> Rt.rt_dont_redirect_key_press_from wid)
      sc.graph.zooms_dam;
    List.iter (fun wid -> Rt.rt_dont_redirect_key_press_from wid)
      sc.graph.resp_f_time;
  };
};

value button_press_action act _ =
  fun
  [ ButtonEvPress _ _ mbut -> if mbut.item <= 3 then act () else ()
  | _ -> () ]
;

value button_release_action act _ =
  fun
  [ ButtonEvRelease x y _ -> act (x, y)
  | _ -> () ]
;

value action_pack_esc_ret esc_f ret_f wid =
  fun
  [ PackEvKeyPress {item = k} ->
      match k with
      [ K_Escape -> esc_f wid
      | K_Return -> ret_f wid
      | _ -> () ] ]
;

value center_of_subwidget main_wid wid =
  let x = widget_x main_wid in
  let y = widget_y main_wid in
  let w = widget_width main_wid in
  let h = widget_height main_wid in
  (x + w / 2 - widget_width wid / 2, y + h / 2 - widget_height wid / 2)
;
