(* $Id: glob_glob.mli,v 1.38 2011-03-15 09:42:22 deraugla Exp $ *)

type zoom_info 'wid =
  { zi_serial : int;
    zi_init_wid : 'wid;
    zi_n : mutable int;
    zi_x : int;
    zi_y : int;
    zi_d : mutable option (int * int);
    zi_d2 : mutable (int * int);
    zoom_expose_count : mutable int;
    clear_zoom : mutable bool }
;

type zoom 'wid =
  [ Zoom of zoom_info 'wid and 'wid and int and int
  | NoZoom ]
;

type t_gen 'a 'b 'drw 'gc 'font 'wid =
  { scenario : mutable array (scenario_gen 'b);
    ind_of_isc : mutable array int;
    curr_sc : mutable int;
    open_dir : mutable string;
    prefix_number : mutable int;
    last_zoom : mutable int;
    graph_nb : mutable int;
    common : 'a;
    g_fun : gfun 'b 'drw 'gc 'font 'wid }
and scenario_gen 'b =
  { ts : Dtasks.tasks;
    initial_order : mutable array int;
    new_task : mutable array Ast.task_def;
    new_preemption_cost : mutable int;
    new_graph_precedence : mutable list (list int);
    new_latency_constr : mutable list Dtasks.latency;
    new_user_priority : mutable list int;
    show_sub : mutable array bool;
    iparam_of_itask : mutable array int;
    latency_disp_cnt : mutable int;
    expose_sched_cnt : mutable int;
    expose_dameid_cnt : mutable int;
    text_nb_lines : mutable int;
    fname : string;
    coloured : mutable bool;
    graph : 'b }
and gfun 'b 'drw 'gc 'font 'wid =
  { g_record_style_bg_color : (int * int * int) -> unit;
    g_clear_drawable : 'drw -> unit;
    g_commit_display : 'drw -> unit;
    g_draw_arc :
      'drw -> 'gc -> (int * int * int * int) -> (int * int) -> unit;
    g_draw_line : 'drw -> 'gc -> (int * int) -> (int * int) -> unit;
    g_draw_lines : 'drw -> 'gc -> list (int * int) -> unit;
    g_draw_rectangle : 'drw -> 'gc -> (int * int * int * int) -> unit;
    g_fill_arc :
      'drw -> 'gc -> (int * int * int * int) -> (int * int) -> unit;
    g_fill_polygon : 'drw -> 'gc -> list (int * int) -> unit;
    g_fill_rectangle : 'drw -> 'gc -> (int * int * int * int) -> unit;
    g_draw_string : 'drw -> 'gc -> (int * int) -> string -> unit;
    g_erase_draw_string : 'drw -> 'gc -> (int * int) -> string -> unit;
    g_dam_dim : 'drw -> Dim_def.damdim;
    g_drawable_width : 'drw -> int;
    g_drawable_height : 'drw -> int;
    g_schedule_zoom_size : 'b -> zoom 'wid -> (int * int);
    g_inter_task_dy : 'drw -> int;
    g_set_color : 'b -> 'gc -> gcolor -> unit;
    g_set_dashes : 'b -> 'gc -> int -> list int -> unit;
    g_set_font : 'b -> 'gc -> gfont -> unit;
    g_set_line_width :  'b -> 'gc -> int -> unit;
    g_set_pixmap : 'b -> 'gc -> int -> unit;
    g_text_width : 'b -> gfont -> string -> int;
    g_font_size : 'b -> gfont -> int;
    g_xcoord_of_coord : 'drw -> (int * int) -> (int * int);
    g_error : exn -> unit;
    g_treat_pending_events : unit -> unit }
and gcolor =
  [ C_black
  | C_white
  | C_gray
  | C_red
  | C_backg_rep_col
  | C_number of int
  | C_style_bg ]
and gfont =
  [ F_raw
  | F_bigger
  | F_smaller ]
;
