(* $Id: parameters_gtk.ml,v 1.20 2011-11-03 13:17:07 deraugla Exp $ *)

(*
open Ast;
open Data_gtk;
open Dim_def;
open Dtasks;
open Glob_glob;
open Printf;

value rec attach_label wid top left =
  fun
  [ [lab :: list] -> do {
      let swid =
        GtkMisc.Label.create
          [Gobject.param GtkMisc.Label.P.label lab;
           Gobject.param GtkMisc.Label.P.use_markup True]
      in
      GtkBase.Widget.show swid;
      GtkPack.Table.attach wid swid ~{left; top};
      attach_label wid top (left + 1) list
    }
  | [] -> left ]
;

value has_sub_dur sc =
  loop 0 where rec loop itask =
    if itask = Array.length sc.new_task then False
    else if sc.new_task.(itask).sub_duration = [] && not sc.show_sub.(itask)
    then loop (itask + 1)
    else True
;

value task_lines_header_wid wid sc = do {
  let top = 0 in
  let left = 0 in
  let left =
    attach_label wid top left
      [""; ""; I18n.transl "release"; I18n.transl "duration"]
  in
  let left =
    if has_sub_dur sc then
      attach_label wid top left
        [I18n.transl "sub-release"; I18n.transl "sub-duration"]
    else left
  in
  let _ =
    attach_label wid top left
      [I18n.transl "deadline"; I18n.transl "period";
       "<small><i>(1)</i></small>"; "<small><i>(2)</i></small>";
       I18n.transl "preemption"]
  in
  ()
};

value signal_connect ~{sgn; callback} item =
  ignore (GtkSignal.connect ~{sgn; callback} item : GtkSignal.id)
;

value param_dial_cancel = 0;
value param_dial_reset = 1;
value param_dial_ok = 2;

value spin_button_sub_wid param_dial wid left top min get set = do {
  let swid = do {
    let adj =
       GtkData.Adjustment.create
         ~{\value = float get; lower = float min; upper = 999999.;
           step_incr = 1.0; page_incr = 10.0; page_size = 0.0}
    in
    GtkEdit.SpinButton.create
      [Gobject.param GtkEdit.SpinButton.P.adjustment adj;
       Gobject.param GtkEdit.SpinButton.P.climb_rate 0.0;
       Gobject.param GtkEdit.SpinButton.P.digits 0;
       Gobject.param GtkEdit.SpinButton.P.wrap False];
  }
  in
  signal_connect
    ~{sgn = GtkEdit.SpinButton.S.value_changed;
      callback () = do {
        let v = GtkEdit.SpinButton.get_value_as_int swid in
        set v;
      }}
     swid;
  signal_connect
    ~{sgn = GtkBase.Widget.Signals.Event.key_press;
      callback ev = do {
        let ksym = GdkEvent.Key.keyval ev in
        if ksym = GdkKeysyms._Escape then
          GtkWindow.Dialog.response param_dial param_dial_cancel
        else if ksym = GdkKeysyms._Return then
          GtkWindow.Dialog.response param_dial param_dial_ok
        else ();
        True
     }}
    swid;
  GtkBase.Widget.show swid;
  GtkPack.Table.attach wid swid ~{left; top};
};

value task_line tg sc itask param_dial wid top = do {
  let left = 0 in
  let swid =
    let (r, g, b) =
      tg.common.color.(itask mod Array.length tg.common.color)
    in
    GtkMisc.Label.create
      [Gobject.param GtkMisc.Label.P.label
         (sprintf " <span color=\"#%02x%02x%02x\">t%d</span>" (r / 256)
            (g / 256) (b /256) (itask + 1));
       Gobject.param GtkMisc.Label.P.use_markup True]
  in
  GtkBase.Widget.show swid;
  GtkPack.Table.attach wid swid ~{left; top};
  let left = left + 1 in
  let left = left + 1 in

  let nt = sc.new_task in
  let td = nt.(itask) in
  spin_button_sub_wid param_dial wid left top (-9999) td.release
    (fun v -> nt.(itask) := {(td) with release = v});
  let left = left + 1 in
  spin_button_sub_wid param_dial wid left top 1 td.duration
    (fun v -> nt.(itask) := {(td) with duration = v});
  let left = left + 1 in

  let left = if has_sub_dur sc then left + 2 else left in

  spin_button_sub_wid param_dial wid left top 0 td.deadline
    (fun v -> nt.(itask) := {(td) with deadline = v});
  let left = left + 1 in
  spin_button_sub_wid param_dial wid left top 1 td.period
    (fun v -> nt.(itask) := {(td) with period = v});
  let left = left + 1 in

  let swid =
    GtkButton.ToggleButton.create_check
      [Gobject.param GtkButton.ToggleButton.P.active td.non_preemptive]
  in
  GtkBase.Widget.show swid;
  GtkPack.Table.attach wid swid ~{left; top};
  let left = left + 1 in
  let swid =
    GtkButton.ToggleButton.create_check
      [Gobject.param GtkButton.ToggleButton.P.active td.strict_per]
  in
  GtkBase.Widget.show swid;
  GtkPack.Table.attach wid swid ~{left; top};
  let left = left + 1 in

  spin_button_sub_wid param_dial wid left top 0 td.pree_cost
    (fun v -> nt.(itask) := {(td) with pree_cost = v});
  let left = left + 1 in

  let swid =
    GtkButton.Button.create
      [Gobject.param GtkButton.Button.P.label (I18n.transl "remove")]
  in
  signal_connect GtkButton.Button.S.clicked
    (fun () -> do { printf "remove\n"; flush stdout }) swid;
  GtkBase.Widget.show swid;
  GtkPack.Table.attach wid swid ~{left; top};
};

value task_line_dur param_dial wid sc itask top isub = do {
  let left = 4 in
  spin_button_sub_wid param_dial wid left top 0 42 (fun v -> ());
  let left = left + 1 in
  spin_button_sub_wid param_dial wid left top 0 43 (fun v -> ());
  top + 1
};

value task_line_add_sub_button wid sc itask top = do {
  let left = 4 in
  let swid = do {
    let wid = GtkPack.Box.create `HORIZONTAL [] in
    let swid =
      GtkButton.Button.create
       [Gobject.param GtkButton.Button.P.label (I18n.transl "add sub-task")]
    in
    GtkBase.Widget.show swid;
    GtkPack.Box.pack wid swid;
    wid
  }
  in
  GtkBase.Widget.show swid;
  GtkPack.Table.attach wid swid ~{left; right = left + 5; top};
  top + 1
};

value label_markup_sub_wid wid left top lab = do {
  let swid = do {
    let wid = GtkPack.Box.create `HORIZONTAL [] in
    let swid =
      GtkMisc.Label.create
        [Gobject.param GtkMisc.Label.P.label lab;
         Gobject.param GtkMisc.Label.P.use_markup True]
    in
    GtkBase.Widget.show swid;
    GtkPack.Box.pack wid swid;
    wid
  }
  in
  GtkBase.Widget.show swid;
  GtkPack.Table.attach wid swid ~{left; top; right = 4};
};

value build_task_table tg sc param_dial = do {
  let wid =
    GtkBin.Alignment.create
      [Gobject.param GtkBin.Alignment.P.xalign 0.5;
       Gobject.param GtkBin.Alignment.P.xscale 0.1]
  in
  let swid = do {
    let wid =
      GtkPack.Table.create [Gobject.param GtkPack.Table.P.column_spacing 10]
    in
    if Array.length sc.new_task = 0 then ()
    else do {
      task_lines_header_wid wid sc;
      let top =
        loop 0 1 where rec loop itask top = do {
          if itask = Array.length sc.new_task then top
          else do {
            task_line tg sc itask param_dial wid top;
            let top = top + 1 in
            let td = sc.new_task.(itask) in
            let top =
              if td.sub_duration = [] && not sc.show_sub.(itask) then top
              else do {
                let top = task_line_dur param_dial wid sc itask top 0 in
                loop top 1 td.sub_duration
                where rec loop top isub =
                  fun
                  [ [] -> task_line_add_sub_button wid sc itask top
                  | [_ :: sub_dur] -> do {
                      let top =
                        task_line_dur param_dial wid sc itask top isub
                      in
                      loop (top + 1) (isub + 1) sub_dur
                    } ]
              }
            in
            loop (itask + 1) top
          }
        }
      in
      label_markup_sub_wid wid 0 top
         (sprintf "<small><i>(1)%s %s</i></small>" (I18n.transl ":")
            (I18n.transl "non preemptive"));
      let top = top + 1 in
      label_markup_sub_wid wid 0 top
         (sprintf "<small><i>(2)%s %s</i></small>" (I18n.transl ":")
            (I18n.transl "strict periodicity"));
    };
    wid;
  }
  in
  GtkBase.Widget.show swid;
  GtkBase.Container.add wid swid;
  wid
};

value max_tasks = 15;

value action_add_task tg sc param_dial table_wid_noteb = do {
  if Array.length sc.new_task = max_tasks then ()
  else do {
    let itask = Array.length sc.new_task in
    let td =
      {release = 0; duration = 1; sub_duration = []; deadline = 10;
       period = 10; user_release = 0; non_preemptive = False;
       strict_per = False; pree_cost = 0}
    in
    let iparam = if itask = 0 then 0 else sc.iparam_of_itask.(itask-1) + 1 in
    sc.iparam_of_itask := Array.append sc.iparam_of_itask [| iparam |];
    sc.new_task := Array.append sc.new_task [| td |];
    sc.show_sub := Array.append sc.show_sub [| False |];
    let swid = build_task_table tg sc param_dial in
    GtkBase.Widget.show swid;
    let _ : int =
      GtkPack.Notebook.insert_page_menu table_wid_noteb swid
        ~{tab_label = Gpointer.optboxed None;
          menu_label = Gpointer.optboxed None}
        ?{pos = None}
    in
    GtkPack.Notebook.remove_page table_wid_noteb 0;
  }
};

value parameter_cancel_action tg param_wid = do {
  let no_sc = Array.length tg.scenario = 0 in
  if no_sc then tg.scenario := [| |] else ();
  GtkBase.Object.destroy param_wid;
};

value parameter_reset_action tg sc param_dial table_wid_noteb = do {
  let ts = sc.ts in
  let tc = ts.ast.constraints in
  sc.new_task := Array.copy ts.ast.tasks_def;
  sc.new_preemption_cost := tc.preemption_cost;
  sc.new_graph_precedence := tc.graph_precedence;
  sc.new_latency_constr := ts.latency_constr;
  sc.show_sub :=
    Array.init (Array.length ts.ast.tasks_def)
      (fun itask -> ts.ast.tasks_def.(itask).sub_duration <> []);
  sc.iparam_of_itask :=
    Array.init (Array.length ts.ast.tasks_def) (fun i -> i);
  let swid = build_task_table tg sc param_dial in
  GtkBase.Widget.show swid;
  let _ : int =
    GtkPack.Notebook.insert_page_menu table_wid_noteb swid
      ~{tab_label = Gpointer.optboxed None;
        menu_label = Gpointer.optboxed None}
      ?{pos = None}
  in
  GtkPack.Notebook.remove_page table_wid_noteb 0;
};

value parameter_ok_action tg no_sc param_wid gi = do  {
  if no_sc then do {
    Scenario_gtk.build_scenario_windows tg gi 0;
    Gobject.set GtkPack.Notebook.P.page gi.main_noteb 1;
  }
  else ();
  GtkBase.Object.destroy param_wid;
  let isc = tg.curr_sc in
  let sc = tg.scenario.(isc) in
  if no_sc || Array.length sc.new_task <> Array.length sc.ts.ast.tasks_def
  then do {
    let many_tasks = Dim.many_tasks sc.new_task in
    sc.graph.inter_task_dy := if many_tasks then 35 else 40;
    match Scenario_gtk.g_widget_named tg "sched" with
    [ Gtkn.DrawingAreaWid wid -> do {
        let width = 1 in
        let height = Dim.schedule_height (Array.length sc.new_task) in
        GtkMisc.DrawingArea.size wid ~{width; height}
      }
    | _ -> assert False ]
  }
  else ();
  Parameters.ok_change_parameters sc;
  let dim = sc.graph.dam_dim in
  sc.graph.dam_dim :=
    Dim.dim_of_width_height sc.ts dim.dam_width dim.dam_height;
  let gc = (Lazy.force gi.lazy_gc, (ref None, ref 0)) in
  Schedule.goto_begin_schedule sc.ts;
  Scenario_gtk.redisplay tg gc;
};

value parameter_wdesc tg gi no_sc sc param_dial = do {
  let param_dial_vbox = GtkWindow.Dialog.vbox param_dial in
  let (param_frame_wid, table_wid_noteb) = do {
    let wid = do {
      let label_opt =
        if sc.fname <> ""  then do {
          let label =
            GtkMisc.Label.create
              [Gobject.param GtkMisc.Label.P.label
                  (sprintf " <small><i>%s</i></small>" sc.fname);
               Gobject.param GtkMisc.Label.P.use_markup True]
          in
          GtkBase.Widget.show label;
          Some (GtkBase.Widget.cast label)
        }
        else None
      in
      GtkBin.Frame.create
        [Gobject.param GtkBin.Frame.P.label_widget label_opt;
         Gobject.param GtkBin.Frame.P.label_xalign 0.5]
    }
    in
    let (param_wid, table_wid_noteb) = do {
      let wid = GtkPack.Box.create `VERTICAL [] in

      let table_wid_noteb =
        GtkPack.Notebook.create
          [Gobject.param GtkPack.Notebook.P.show_tabs False;
           Gobject.param GtkPack.Notebook.P.show_border False]
      in
      GtkBase.Widget.show table_wid_noteb;
      GtkPack.Box.pack wid table_wid_noteb;

      let swid = build_task_table tg sc param_dial in
      GtkBase.Widget.show swid;
      let _ : int =
        GtkPack.Notebook.insert_page_menu table_wid_noteb swid
          ~{tab_label = Gpointer.optboxed None;
            menu_label = Gpointer.optboxed None}
          ?{pos = None}
      in

      let swid = do {
        let wid = GtkPack.Box.create `HORIZONTAL [] in
        let swid =
          GtkButton.Button.create
            [Gobject.param GtkButton.Button.P.label (I18n.transl "add task")]
        in
        GtkBase.Widget.show swid;
        GtkPack.Box.pack wid swid;
        signal_connect GtkButton.Button.S.clicked
          (fun () -> action_add_task tg sc param_dial table_wid_noteb) swid;
        wid
      }
      in
      GtkBase.Widget.show swid;
      GtkPack.Box.pack wid swid ~{from = `START};
      let pree_line_wid = do {
        let wid = GtkPack.Box.create `HORIZONTAL [] in
        let pree_cost_frame_wid = do {
          let wid =
            GtkBin.Frame.create [Gobject.param GtkBin.Frame.P.label None]
          in
          let pree_cost_box_wid = do {
            let wid = GtkPack.Box.create `HORIZONTAL [] in
            let swid =
              GtkMisc.Label.create
                [Gobject.param GtkMisc.Label.P.label
                   (sprintf "%s (%s) " (I18n.transl "preemption cost")
                      (I18n.transl "default"));
                 Gobject.param GtkMisc.Label.P.use_markup True]
            in
            GtkBase.Widget.show swid;
            GtkPack.Box.pack wid swid;
            let swid = do {
              let adj =
                 GtkData.Adjustment.create
                   ~{\value = float sc.new_preemption_cost; lower = 0.;
                     upper = 99999.; step_incr = 1.0; page_incr = 10.0;
                     page_size = 0.0}
              in
              GtkEdit.SpinButton.create
                [Gobject.param GtkEdit.SpinButton.P.adjustment adj;
                 Gobject.param GtkEdit.SpinButton.P.climb_rate 0.0;
                 Gobject.param GtkEdit.SpinButton.P.digits 0;
                 Gobject.param GtkEdit.SpinButton.P.wrap False]
            }
            in
            signal_connect swid
              ~{sgn = GtkEdit.SpinButton.S.value_changed;
                callback () = do {
                  let v = GtkEdit.SpinButton.get_value_as_int swid in
                  sc.new_preemption_cost := v;
                }};
            GtkBase.Widget.show swid;
            GtkPack.Box.pack wid swid ~{from = `START};
            wid
          }
          in
          GtkBase.Widget.show pree_cost_box_wid;
          GtkBase.Container.add wid pree_cost_box_wid;
          wid
        }
        in
        GtkBase.Widget.show pree_cost_frame_wid;
        GtkPack.Box.pack wid pree_cost_frame_wid ~{from = `START};
        let lcm_frame_wid = do {
          let wid =
            GtkBin.Frame.create [Gobject.param GtkBin.Frame.P.label None]
          in
          let swid = do {
            let wid = GtkPack.Box.create `HORIZONTAL [] in
            let swid =
              GtkMisc.Label.create
                [Gobject.param GtkMisc.Label.P.label (I18n.transl "LCM");
                 Gobject.param GtkMisc.Label.P.use_markup True]
            in
            GtkBase.Widget.show swid;
            GtkPack.Box.pack wid swid;
            let swid = GtkEdit.Entry.create [] in
            GtkBase.Widget.show swid;
            GtkPack.Box.pack wid swid;
            wid
          }
          in
          GtkBase.Widget.show swid;
          GtkBase.Container.add wid swid;
          wid
        }
        in
        GtkBase.Widget.show lcm_frame_wid;
        GtkPack.Box.pack wid lcm_frame_wid ~{from = `END};
        let fact_util_frame_wid = do {
          let wid =
            GtkBin.Frame.create [Gobject.param GtkBin.Frame.P.label None]
          in
          let fact_util_box_wid = do {
            let wid = GtkPack.Box.create `HORIZONTAL [] in
            let fact_util_label_wid =
              GtkMisc.Label.create
                [Gobject.param GtkMisc.Label.P.label
                   (sprintf "%s " (I18n.transl "util.fact."))]
            in
            GtkBase.Widget.show fact_util_label_wid;
            GtkPack.Box.pack wid fact_util_label_wid ~{from = `START};
            let fact_util_wid = GtkEdit.Entry.create [] in
            GtkBase.Widget.show fact_util_wid;
            GtkPack.Box.pack wid fact_util_wid;
            wid
          }
          in
          GtkBase.Widget.show fact_util_box_wid;
          GtkBase.Container.add wid fact_util_box_wid;
          wid
        }
        in
        GtkBase.Widget.show fact_util_frame_wid;
        GtkPack.Box.pack wid fact_util_frame_wid ~{from = `END};
        wid
      }
      in
      GtkBase.Widget.show pree_line_wid;
      GtkPack.Box.pack wid pree_line_wid ~{from = `START};
      let beg_ex = "<small><tt><i><span color=\"purple\">" in
      let end_ex = "</span></i></tt></small>" in
      let pree_ex_box_wid = do {
        let wid = GtkPack.Box.create `HORIZONTAL [] in
        let pree_ex_wid =
          GtkMisc.Label.create
            [Gobject.param GtkMisc.Label.P.label
               (sprintf "%s (%s%s %s%s%s)"
                  (I18n.transl "precedence") (I18n.transl "example")
                  (I18n.transl ":") beg_ex "t1&lt;t7&lt;t2 t4&lt;t3" end_ex);
             Gobject.param GtkMisc.Label.P.use_markup True;
             Gobject.param GtkMisc.Label.P.selectable True]
        in
        GtkBase.Widget.show pree_ex_wid;
        GtkPack.Box.pack wid pree_ex_wid ~{from = `START};
        wid
      }
      in
      GtkBase.Widget.show pree_ex_box_wid;
      GtkPack.Box.pack wid pree_ex_box_wid ~{from = `START};
      let graph_prec_text_wid =
        GtkEdit.Entry.create
          [Gobject.param GtkEdit.Entry.P.text
             (Schedule.string_of_graph_prec sc.new_graph_precedence)]
      in
      let pango = Pango.Font.from_string "Monospace 12" in
      GtkBase.Widget.modify_font graph_prec_text_wid pango;
      GtkBase.Widget.show graph_prec_text_wid;
      GtkPack.Box.pack wid graph_prec_text_wid;
      let lat_ex_box_wid = do {
        let wid = GtkPack.Box.create `HORIZONTAL [] in
        let lat_ex_wid =
          GtkMisc.Label.create
            [Gobject.param GtkMisc.Label.P.label
               (sprintf "%s (%s%s %s%s%s)"
                  (I18n.transl "latency") (I18n.transl "example")
                  (I18n.transl ":") beg_ex
                  "t3(4)->t1(7)&lt;22 t2(8)->t1(5)&lt;12" end_ex);
             Gobject.param GtkMisc.Label.P.use_markup True;
             Gobject.param GtkMisc.Label.P.selectable True]
        in
        GtkBase.Widget.show lat_ex_wid;
        GtkPack.Box.pack wid lat_ex_wid ~{from = `START};
        wid
      }
      in
      GtkBase.Widget.show lat_ex_box_wid;
      GtkPack.Box.pack wid lat_ex_box_wid ~{from = `START};
      let lat_text_wid =
        GtkEdit.Entry.create
          [Gobject.param GtkEdit.Entry.P.text
             (Schedule.string_of_latency sc.new_latency_constr)]
      in
      let pango = Pango.Font.from_string "Monospace 12" in
      GtkBase.Widget.modify_font lat_text_wid pango;
      GtkBase.Widget.show lat_text_wid;
      GtkPack.Box.pack wid lat_text_wid;
      let prio_ex_box_wid = do {
        let wid = GtkPack.Box.create `HORIZONTAL [] in
        let prio_ex_wid =
          GtkMisc.Label.create
            [Gobject.param GtkMisc.Label.P.label
               (sprintf "%s (%s%s %s%s%s)"
                  (I18n.transl "priority") (I18n.transl "example")
                  (I18n.transl ":") beg_ex "t1,t3,t2,t4,t5" end_ex);
             Gobject.param GtkMisc.Label.P.use_markup True;
             Gobject.param GtkMisc.Label.P.selectable True]
        in
        GtkBase.Widget.show prio_ex_wid;
        GtkPack.Box.pack wid prio_ex_wid ~{from = `START};
        wid
      }
      in
      GtkBase.Widget.show prio_ex_box_wid;
      GtkPack.Box.pack wid prio_ex_box_wid ~{from = `START};
      let prio_text_wid =
        GtkEdit.Entry.create
          [Gobject.param GtkEdit.Entry.P.text
             (Schedule.string_of_user_priority sc.new_user_priority)]
      in
      let pango = Pango.Font.from_string "Monospace 12" in
      GtkBase.Widget.modify_font prio_text_wid pango;
      GtkBase.Widget.show prio_text_wid;
      GtkPack.Box.pack wid prio_text_wid;
      (wid, table_wid_noteb)
    }
    in
    GtkBase.Widget.show param_wid;
    GtkBase.Container.add wid param_wid;
    (wid, table_wid_noteb)
  }
  in
  GtkBase.Widget.show param_frame_wid;
  GtkBase.Container.add param_dial_vbox param_frame_wid;

  GtkWindow.Dialog.add_button param_dial "Cancel" param_dial_cancel;
  GtkWindow.Dialog.add_button param_dial "Reset" param_dial_reset;
  GtkWindow.Dialog.add_button param_dial "OK" param_dial_ok;
  GtkWindow.Dialog.set_default_response param_dial param_dial_ok;
  signal_connect param_dial
    ~{sgn = GtkWindow.Dialog.S.response;
      callback x = do {
        if x = param_dial_cancel then parameter_cancel_action tg param_dial
        else if x = param_dial_reset then
          parameter_reset_action tg sc param_dial table_wid_noteb
        else if x = param_dial_ok then
          parameter_ok_action tg no_sc param_dial gi
        else do {
          printf "param_dial %d\n" x;
          flush stdout
        }
      }};
};
*)
