(* $Id: scenario_gtk.ml,v 1.32 2011-11-03 13:17:07 deraugla Exp $ *)

(*
open Printf;

open Ast;
open Data_gtk;
open Dtasks;
open Glob_glob;

value drawable_of_zoom wid size sc zoom =
  let wid =
    match zoom with
    [ Zoom _ wid _ _ -> wid
    | NoZoom -> wid ]
  in
  let dr = Gtkn.WindowDr (Gtkn.widget_window wid) in
  (dr, (size, sc.graph))
;

value isc_of_ind ind_of_isc ind =
  loop 0 where rec loop isc =
    if isc = Array.length ind_of_isc then failwith "isc_of_ind"
    else if ind_of_isc.(isc) = ind then isc
    else loop (isc + 1)
;

value erase_scenario tg gi ind = do {
  let isc = isc_of_ind tg.ind_of_isc ind in
(*
  printf "*** erase scenario\n";
  printf "isc %d\n" isc;
  printf "ind_of_isc = %d\n" tg.ind_of_isc.(isc);
  flush stdout;
*)
  let ind_of_isc =
    Array.init (Array.length tg.ind_of_isc - 1)
      (fun j -> tg.ind_of_isc.(if j < isc then j else j + 1))
  in
  tg.ind_of_isc := ind_of_isc;
  let scenario =
    Array.init (Array.length tg.scenario - 1)
      (fun j -> tg.scenario.(if j < isc then j else j + 1))
  in
  tg.scenario := scenario;
  if isc < tg.curr_sc then tg.curr_sc := tg.curr_sc - 1
  else if isc = tg.curr_sc then do {
    let new_i =
      if isc = Array.length tg.scenario then max 0 (isc - 1) else isc
    in
    tg.curr_sc := new_i
  }
  else ();
  GtkPack.Notebook.remove_page gi.scen_noteb isc;
  if Array.length tg.scenario = 0 then
    Gobject.set GtkPack.Notebook.P.page gi.main_noteb 0
  else ()
};

value unfreeze_d wid zi x y w h =
  match zi.zi_d with
  [ Some d -> d
  | None -> do {
      let dx = w / 2 - x in
      let dy = w / 2 - y in
      zi.zi_d := Some (dx, dy);
      (dx, dy)
    } ]
;

value expose_zoom_schedule tg sc gc zi zoom_wid = do {
  let gfun = tg.g_fun in
(*
  let (dx, dy) = unfreeze_d zoom_wid zi in
*)
  let (dx, dy) = (0, 0) in
(**)
  let (dx2, dy2) = zi.zi_d2 in
  let zoom = Zoom zi zoom_wid (dx + dx2) (dy + dy2) in
  let drw = drawable_of_zoom zoom_wid sc.graph.sched_size sc zoom in
  gfun.g_clear_drawable drw;
  Draw_schedule.draw_repetition gfun sc drw gc zoom;
  Draw_schedule.draw_units gfun sc drw gc zoom;
  Draw_schedule.draw_skeleton gfun sc drw gc zoom;
  Draw_schedule.draw_latencies gfun sc drw gc zoom False;

  let (w, h) = gfun.g_schedule_zoom_size sc.graph zoom in
  let x = w / 2 - dx in
  let y = h / 2 - dy in
  let r = 5 in
  gfun.g_set_color sc.graph gc C_black;
  gfun.g_set_line_width sc.graph gc 1;
  gfun.g_draw_arc drw gc (x - r, y - r, 2 * r, 2 * r) (0, 360 * 64);
};

value draw_schedule_gtk_min_zoom_dx gd zi =
  zi.zi_n * (Draw_schedule.left_sched - zi.zi_x)
;
value draw_schedule_gtk_max_zoom_dx gd zi =
  let sched_width = fst gd.graph.sched_size.val in
  zi.zi_n * (Draw_schedule.right_sched sched_width - zi.zi_x)
;
value draw_schedule_gtk_min_zoom_dy gd zi =
  gd.graph.inter_task_dy - zi.zi_y
;
value draw_schedule_gtk_max_zoom_dy gd zi =
  gd.graph.inter_task_dy * (Array.length gd.ts.ast.tasks_def) - zi.zi_y
;

value widget_named tg name = do {
  if tg.curr_sc < Array.length tg.scenario then do {
    let isc = tg.curr_sc in
    let sc = tg.scenario.(isc) in
    try Hashtbl.find sc.graph.widget_ht name with
    [ Not_found -> failwith (sprintf "widget '%s' not found" name) ]
  }
  else do {
    failwith "widget_named with isc out of bounds"
  }
};

value g_widget_named tg main_name = do {
  if tg.curr_sc < Array.length tg.scenario then do {
    let isc = tg.curr_sc in
    let name = sprintf "%s_%d" main_name tg.ind_of_isc.(isc) in
    widget_named tg name
  }
  else do {
    failwith "g_widget_named with isc out of bounds"
  }
};

value expose_zoom_tasks_names sc zi wid = do {
  eprintf "expose_zoom_tasks_names not impl\n";
  flush stderr
};

value adjust_zoom_schedule_and_expose tg sc gc zi zoom_wid (dx2, dy2) = do {
  let dx2 = min dx2 (draw_schedule_gtk_max_zoom_dx sc zi) in
  let dx2 = max dx2 (draw_schedule_gtk_min_zoom_dx sc zi) in
  let dy2 = min dy2 (draw_schedule_gtk_max_zoom_dy sc zi) in
  let dy2 = max dy2 (draw_schedule_gtk_min_zoom_dy sc zi) in
  if zi.zi_d2 <> (dx2, dy2) then do {
    zi.zi_d2 := (dx2, dy2);
    zi.zi_d := Some (0, 0);
    let win = GtkBase.Widget.window zoom_wid in
    Gdk.Window.clear win;
    let zoom_wid = Gtkn.DrawingAreaWid zoom_wid in
    expose_zoom_schedule tg sc gc zi zoom_wid;
    let ztn = sprintf "zoom_tasks_names_%d" zi.zi_serial in
    let wid = widget_named tg ztn in
    match wid with
    [ Gtkn.DrawingAreaWid da -> Gdk.Window.clear (GtkBase.Widget.window da)
    | _ -> () ];
    expose_zoom_tasks_names sc zi wid
  }
  else ()
};

value destroy_zoom_schedule sc wid ser = do {
  sc.graph.zooms_sch :=
    List.filter (fun (_, _, zi) -> zi.zi_serial <> ser) sc.graph.zooms_sch;
  GtkBase.Object.destroy wid;
};

value signal_connect ~{sgn; callback} item =
  ignore (GtkSignal.connect ~{sgn; callback} item : GtkSignal.id)
;

value zoom_cnt = ref 0;
value display_zoom_schedule tg gi sched_wid x y x_root y_root = do {
  let gc = (Lazy.force gi.lazy_gc, (ref None, ref 0)) in
  let n = 2 in
  let w = 500 in
  let h = 250 in
  incr zoom_cnt;
  let zoom_name = sprintf "zoom_%d" zoom_cnt.val in
  let zi =
    {zi_serial = zoom_cnt.val; zi_init_wid = sched_wid; zi_n = n;
     zi_x = x; zi_y = y; zi_d = None; zi_d2 = (0, 0); zoom_expose_count = 0;
     clear_zoom = False}
  in
  let sc = tg.scenario.(tg.curr_sc) in
  let wid = do {
    let wid =
      GtkWindow.Window.create
        [Gobject.param GtkWindow.Window.P.title "zoom";
         Gobject.param GtkWindow.Window.P.transient_for (Some gi.root_wid)]
    in
    let box = GtkPack.Box.create `HORIZONTAL [] in
    GtkBase.Container.add wid box;
    GtkBase.Widget.show box;
    let tasks_names_wid = GtkMisc.DrawingArea.create [] in
    GtkMisc.DrawingArea.size tasks_names_wid 50 h;
    GtkBase.Widget.show tasks_names_wid;
    GtkBase.Container.add box tasks_names_wid;
    let ztn = sprintf "zoom_tasks_names_%d" zi.zi_serial in
    signal_connect GtkBase.Widget.Signals.Event.expose
      (fun _ -> do {
         let wid = Gtkn.DrawingAreaWid tasks_names_wid in
         expose_zoom_tasks_names sc zi wid;
         False
       })
      tasks_names_wid;
    Hashtbl.add sc.graph.widget_ht ztn (Gtkn.DrawingAreaWid tasks_names_wid);

    let zoom_wid = GtkMisc.DrawingArea.create [] in
    GtkMisc.DrawingArea.size zoom_wid ~{width = w; height = h};
    GtkBase.Widget.show zoom_wid;
    signal_connect GtkBase.Widget.Signals.Event.expose
      (fun _ -> do {
         let zoom_wid = Gtkn.DrawingAreaWid zoom_wid in
         expose_zoom_schedule tg sc gc zi zoom_wid;
         False
       })
      zoom_wid;
    signal_connect GtkBase.Object.S.destroy
      (fun () -> destroy_zoom_schedule sc wid zi.zi_serial) wid;
    signal_connect GtkBase.Widget.Signals.Event.key_press
      (fun ev -> do {
         match GdkEvent.Key.string ev with
         [ "\027" -> destroy_zoom_schedule sc wid zi.zi_serial
         | "u" -> do {
             let n = zi.zi_n / 2 in
             if n = 0 then ()
             else do {
               zi.zi_n := n;
(*
               let (dx2, dy2) = zi.zi_d2 in
*)
               zi.zi_d2 := (1, 1);
               expose_zoom_schedule tg sc gc zi
                 (Gtkn.DrawingAreaWid zoom_wid);
             }
           }
         | "z" -> do {
             let n = zi.zi_n * 2 in
             if n > 10000 then ()
             else do {
               zi.zi_n := n;
(*
               let (dx2, dy2) = zi.zi_d2 in
*)
               zi.zi_d2 := (1, 1);
               expose_zoom_schedule tg sc gc zi
                 (Gtkn.DrawingAreaWid zoom_wid);
             }
           }
         | s -> GtkMain.Event.propagate gi.root_wid ev ];
         False
       })
      wid;
    signal_connect GtkBase.Widget.Signals.Event.button_press
      (fun ev -> do {
(*
         let w = widget_width wid in
         let h = widget_height wid in
*)
         let x = truncate (GdkEvent.Button.x ev) in
         let y = truncate (GdkEvent.Button.y ev) in
         let (dx, dy) = unfreeze_d wid zi x y w h in
         let (dx2, dy2) = zi.zi_d2 in
         let dx2 = dx2 + x + dx - w / 2 in
         let dy2 = dy2 + y + dy - h / 2 in
         adjust_zoom_schedule_and_expose tg sc gc zi zoom_wid (dx2, dy2);
         False
       })
      wid;
    GtkBase.Widget.add_events wid [`KEY_PRESS; `BUTTON_PRESS];
    GtkBase.Container.add box zoom_wid;
    Hashtbl.add sc.graph.widget_ht zoom_name (Gtkn.DrawingAreaWid zoom_wid);
    sc.graph.zooms_sch :=
      [(wid, Gtkn.DrawingAreaWid zoom_wid, zi) :: sc.graph.zooms_sch];
    wid
  }
  in
  GtkBase.Widget.show wid;
  GtkWindow.Window.move wid (x_root - w / 2) (y_root - h / 2);
};

value expose_sched tg gc = do {
  let isc = tg.curr_sc in
  let sc = tg.scenario.(isc) in
  let sched_wid = g_widget_named tg "sched" in
  let sched_drw = drawable_of_zoom sched_wid sc.graph.sched_size sc NoZoom in
  Draw_schedule.draw_schedule tg.g_fun sc sched_drw gc;
  List.iter (fun (_, wid, zi) -> expose_zoom_schedule tg sc gc zi wid)
    sc.graph.zooms_sch;
};

value expose_dam tg gc = do {
  let isc = tg.curr_sc in
  let sc = tg.scenario.(isc) in
  let dam_wid = g_widget_named tg "dameid" in
  let dam_drw = drawable_of_zoom dam_wid sc.graph.dam_size sc NoZoom in
  let cap_wid = g_widget_named tg "caption" in
  let cap_drw = drawable_of_zoom cap_wid sc.graph.cap_size sc NoZoom in
  let gfun = tg.g_fun in
  gfun.g_clear_drawable dam_drw;
  Draw_dameid.draw_sectors gfun sc sc.graph dam_drw gc NoZoom;
  Draw_dameid.draw_skeleton gfun sc dam_drw gc NoZoom;
  Draw_dameid.draw_latencies gfun sc dam_drw gc NoZoom False;
  gfun.g_commit_display dam_drw;
  Draw_dameid.draw_caption gfun sc cap_drw gc;
  match tg.common.radialgo with
  [ Some radialgo -> do {
      let algo = sc.ts.ast.algorithm in
      let nalgo =
        match algo with
        [ AL_deadline_monotonic -> 0
        | AL_rate_monotonic -> 1
        | AL_edf -> 2
        | AL_audsley _ -> 3
        | AL_user _ -> 4 ]
      in
      let wid = List.nth radialgo nalgo in
      if not (Gobject.get GtkMenu.CheckMenuItem.P.active wid) then do {
        tg.common.ignore_radialgo_callback := True;
        GtkMenu.CheckMenuItem.set ~{active = True} wid
      }
      else ()
    }
  | None -> () ]
};

value expose_text tg gc = do {
  let isc = tg.curr_sc in
  let sc = tg.scenario.(isc) in
  let tex_wid = g_widget_named tg "text" in
  let tex =
    match tex_wid with
    [ Gtkn.LabelWid tex -> tex
    | _ -> failwith "internal error tex" ]
  in
  let buff = Buffer.create 1 in
  Buffer.add_char buff ' ';
  let print s =
    loop 0 where rec loop i =
      if i = String.length s then ()
      else do {
        match s.[i] with
        [ '\027' -> do {
            skip_esc (i + 1) where rec skip_esc i =
              if i = String.length s then ()
              else
                match s.[i] with
                [ 'A'..'Z' -> loop (i + 1)
                | _ -> skip_esc (i + 1) ]
          }
        | '\\' -> do {
            if i+1 < String.length s then
              Buffer.add_char buff s.[i+1]
            else
              Buffer.add_char buff '\\';
            loop (i + 2)
          }
        | c -> do {
            match c with
            [ '\r' -> Buffer.add_string buff " \r"
            | '\n' -> Buffer.add_string buff "\n "
            | '<' -> Buffer.add_string buff "&lt;"
            | c -> Buffer.add_char buff c ];
            loop (i + 1)
          } ]
      }
  in
  Schedule.gen_redraw_text print Schedule.vt_pango 50 sc;
  let str = Buffer.contents buff in
  GtkMisc.Label.set_text tex str;
  Gobject.set GtkMisc.Label.P.use_markup tex True;
};

value build_scenario_windows tg gi isc = do {
  let sc = tg.scenario.(isc) in
  let ts = sc.ts.ast in
  let sched_height = Dim.schedule_height (Array.length ts.tasks_def) in
  let sched_height = min (Gdk.Screen.height () * 7 / 20) sched_height in
  sc.graph.sched_size.val := (1, sched_height);
  sc.graph.mes_size.val := (1, sched_height);
  let frame = do {
    let label =
      GtkMisc.Label.create
        [Gobject.param GtkMisc.Label.P.label
            (sprintf " <small><i>%s</i></small>" sc.fname);
         Gobject.param GtkMisc.Label.P.use_markup True]
    in
    GtkBase.Widget.show label;
    GtkBin.Frame.create
      [Gobject.param GtkBin.Frame.P.label_widget
         (Some (GtkBase.Widget.cast label));
       Gobject.param GtkBin.Frame.P.label_xalign 1.0]
  }
  in
  GtkBase.Widget.show frame;
  do {
    let tongue =
      GtkPack.Box.create `HORIZONTAL [Gobject.param GtkPack.Box.P.spacing 10]
    in
    GtkBase.Widget.show tongue;
    let txt = Filename.basename sc.fname in
    let lab =
      GtkMisc.Label.create
        [Gobject.param GtkMisc.Label.P.label txt;
         Gobject.param GtkMisc.Label.P.ellipsize `MIDDLE;
         Gobject.param GtkMisc.Label.P.max_width_chars 15]
    in
    GtkBase.Widget.show lab;
    GtkBase.Container.add tongue lab;
    let close =
      GtkButton.Button.create
        [Gobject.param GtkButton.Button.P.label "x";
         Gobject.param GtkButton.Button.P.relief `NONE]
    in
    GtkBase.Widget.show close;
    GtkBase.Container.add tongue close; 
    let _ : int =
      GtkPack.Notebook.insert_page_menu gi.scen_noteb frame
        ~{tab_label = Gpointer.optboxed (Some tongue);
          menu_label = Gpointer.optboxed None}
        ?{pos = None}
    in
    signal_connect GtkButton.Button.S.clicked
      (fun () -> erase_scenario tg gi isc) close
  };
  let scen = GtkPack.Box.create `VERTICAL [] in
  GtkBase.Widget.show scen;
  GtkBase.Container.add frame scen;

  let sched_mes_noteb =
    GtkPack.Notebook.create
      [Gobject.param GtkPack.Notebook.P.show_tabs False;
       Gobject.param GtkPack.Notebook.P.show_border False]
  in
  GtkBase.Widget.show sched_mes_noteb;
  GtkBase.Container.add scen sched_mes_noteb;

  let sched_wid = do {
    let (w, h) = sc.graph.sched_size.val in
    let wid = GtkMisc.DrawingArea.create [] in
    GtkMisc.DrawingArea.size wid w h;
    GtkBase.Widget.show wid;
    wid
  }
  in
  let mes_wid = do {
    let (w, h) = sc.graph.mes_size.val in
    let wid = GtkMisc.DrawingArea.create [] in
    GtkMisc.DrawingArea.size wid w h;
    GtkBase.Widget.show wid;
    wid
  }
  in

  let sched_name = sprintf "sched_%d" isc in
  Hashtbl.add sc.graph.widget_ht sched_name (Gtkn.DrawingAreaWid sched_wid);
  signal_connect GtkBase.Widget.Signals.Event.configure
    (fun ev -> do {
       let w = GdkEvent.Configure.width ev in
       let h = GdkEvent.Configure.height ev in
       sc.graph.sched_size.val := (w, h);
       False
     })
    sched_wid;
  signal_connect GtkBase.Widget.Signals.Event.button_press
    (fun ev -> do {
       let x = truncate (GdkEvent.Button.x ev) in
       let y = truncate (GdkEvent.Button.y ev) in
       let x_root = truncate (GdkEvent.Button.x_root ev) in
       let y_root = truncate (GdkEvent.Button.y_root ev) in
       display_zoom_schedule tg gi (Gtkn.DrawingAreaWid sched_wid) x y
         x_root y_root;
       False
     })
    sched_wid;
  signal_connect GtkBase.Widget.Signals.Event.expose
    (fun _ -> do {
       let gc = (Lazy.force gi.lazy_gc, (ref None, ref 0)) in
       expose_sched tg gc;
       False
     })
    sched_wid;
  GtkBase.Widget.add_events sched_wid [`BUTTON_PRESS; `EXPOSURE];
  let _ : int =
    GtkPack.Notebook.insert_page_menu sched_mes_noteb sched_wid
      ~{tab_label = Gpointer.optboxed None;
        menu_label = Gpointer.optboxed None}
      ?{pos = None}
  in

  let mes_name = sprintf "mesoid_%d" isc in
  Hashtbl.add sc.graph.widget_ht mes_name (Gtkn.DrawingAreaWid mes_wid);
  let _ : int =
    GtkPack.Notebook.insert_page_menu sched_mes_noteb mes_wid
      ~{tab_label = Gpointer.optboxed None;
        menu_label = Gpointer.optboxed None}
      ?{pos = None}
  in

  let hbox = GtkPack.Box.create `HORIZONTAL [] in
  GtkBase.Widget.show hbox;
  GtkBase.Container.add scen hbox;

  let dam_wid = GtkMisc.DrawingArea.create [] in
  GtkMisc.DrawingArea.size dam_wid
    ~{width = fst sc.graph.dam_size.val;
      height = snd sc.graph.dam_size.val};
  GtkBase.Widget.show dam_wid;
  signal_connect GtkBase.Widget.Signals.Event.configure
    (fun ev -> do {
       let width = GdkEvent.Configure.width ev in
       let height = GdkEvent.Configure.height ev in
       sc.graph.dam_size.val := (width, height);
(**)
       let style = Gobject.get GtkBase.Widget.P.style dam_wid in
       let col = GtkData.Style.get_bg style `NORMAL in
       let r16 = Gdk.Color.red col in
       let g16 = Gdk.Color.green col in
       let b16 = Gdk.Color.blue col in
       tg.g_fun.g_record_style_bg_color (r16, g16, b16);
(*
       let str = sprintf "r %d g %d b %d" r16 g16 b16 in
       printf "gtk record background %s\n" str;
       flush stdout;
*)
(**)
       False
     })
    dam_wid;
  signal_connect GtkBase.Widget.Signals.Event.button_press
    (fun ev -> do {
       let x = GdkEvent.Button.x ev in
       let y = GdkEvent.Button.x ev in
       printf "dam_wid: button pressed %g %g\n" x y;
       flush stdout;
       False
     })
    dam_wid;
  GtkBase.Widget.add_events dam_wid [`BUTTON_PRESS];

  let dam_name = sprintf "dameid_%d" isc in
  Hashtbl.add sc.graph.widget_ht dam_name (Gtkn.DrawingAreaWid dam_wid);
  GtkBase.Container.add hbox dam_wid;

  let caption = do {
    let (w, h) = sc.graph.cap_size.val in
    let wid = GtkMisc.DrawingArea.create [] in
    GtkMisc.DrawingArea.size wid w h;
    GtkBase.Widget.show wid;
    wid
  }
  in
  let cap_name = sprintf "caption_%d" isc in
  Hashtbl.add sc.graph.widget_ht cap_name (Gtkn.DrawingAreaWid caption);
  GtkBase.Container.add hbox caption;

  signal_connect GtkBase.Widget.Signals.Event.expose
    (fun _ -> do {
       let gc = (Lazy.force gi.lazy_gc, (ref None, ref 0)) in
       expose_dam tg gc;
       expose_text tg gc;
       False
     })
    dam_wid;

  let tex_wid =
    GtkMisc.Label.create
      [Gobject.param GtkMisc.Label.P.label "";
       Gobject.param GtkMisc.Label.P.selectable True]
  in
  GtkBase.Widget.show tex_wid;
  let pango = Pango.Font.from_string "Monospace 12" in
  GtkBase.Widget.modify_font tex_wid pango;
  let tex_name = sprintf "text_%d" isc in
  Hashtbl.add sc.graph.widget_ht tex_name (Gtkn.LabelWid tex_wid);
  GtkBase.Container.add hbox tex_wid;
};

value update_draw tg sc gc = do {
  let gfun = tg.g_fun in
  let dam_wid = g_widget_named tg "dameid" in
  let cap_wid = g_widget_named tg "caption" in
  let sched_wid = g_widget_named tg "sched" in
  let mes_wid = g_widget_named tg "mesoid" in
  let dam_drw = drawable_of_zoom dam_wid sc.graph.dam_size sc NoZoom in
  let cap_drw = drawable_of_zoom cap_wid sc.graph.cap_size sc NoZoom in
  let sched_drw =
    drawable_of_zoom sched_wid sc.graph.sched_size sc NoZoom
  in
  Gtkn.widget_realize mes_wid;
  let mes_drw = drawable_of_zoom mes_wid sc.graph.mes_size sc NoZoom in
  Draw_schedule.gen_update_draw tg.g_fun sc gc dam_drw sched_drw mes_drw
    (fun color itask j -> ());
  Draw_dameid.draw_skeleton gfun sc dam_drw gc NoZoom;
  Draw_dameid.draw_caption gfun sc cap_drw gc;
  Draw_schedule.draw_skeleton gfun sc sched_drw gc NoZoom;
  List.iter
    (fun (_, wid, zi) -> expose_zoom_schedule tg sc gc zi wid)
    sc.graph.zooms_sch;
};

value expose tg gc = do {
  expose_dam tg gc;
  expose_text tg gc;
  expose_sched tg gc;
};

value redisplay tg gc = do {
  let dam_wid = g_widget_named tg "dameid" in
  let sched_wid = g_widget_named tg "sched" in
  Gdk.Window.clear (Gtkn.widget_window dam_wid);
  Gdk.Window.clear (Gtkn.widget_window sched_wid);
  expose tg gc;
};
*)
