(* $Id: schedule.mli,v 1.46 2010-11-29 17:43:00 deraugla Exp $ *)

open Dtasks;

exception Schedule_interrupted of schedule_status;

value schedule_all : tasks -> unit;
value schedule_entire_task : tasks -> unit;
value schedule_next_instance : tasks -> unit;
value output_task_data : string -> tasks -> unit;

value next_audsley_schedule :
  tasks -> ((int * int) -> unit) -> Ast.audsley_info -> bool;

value prev_audsley_schedule :
  tasks -> ((int * int) -> unit) -> Ast.audsley_info -> bool;

value print_dameid : out_channel -> tasks -> unit;

value compute_wrt : tasks -> int -> int;
value compute_classical_utilization_factor : tasks -> int;
value compute_exact_utilization : tasks -> int;

value recompute_init : tasks -> unit;
value goto_begin_schedule : tasks -> unit;
value compute_repetitive_part : tasks -> option (int * int);

value string_of_graph_prec : list (list int) -> string;
value string_of_latency : list latency -> string;
value string_of_user_priority : list int -> string;

value get_response_values : tasks -> list (int * list (int * int));

value trace : ref bool;

open Glob_glob;

type vt = 'abstract;

value vt_term : vt;
value vt_pango : vt;

value gen_redraw_text :
  (string -> unit) -> vt -> int -> scenario_gen 'a -> unit;

value constr_info_list :
  vt -> tasks -> int -> (list string * list string * list string)
;