(* $Id: sparse.mli,v 1.11 2011-11-03 13:26:30 deraugla Exp $ *)

open Ast;

type dameid_file =
  { d_tasks : list task_def;
    d_pree_cost : int;
    d_glob_prec : bool;
    d_graph_prec : list (list int);
    d_strict_per : bool;
    d_fully_non_pree : bool;
    d_latency_constr : list latency_constr;
    d_default_algo : option algorithm }
;

value graph_preceding_tasks : list (list 'a) -> 'a -> list 'a;
value compare_priorities : scenario -> int -> int -> int;
value genuine_graph_precedence : int -> list (list int) -> list (list int);
value make_ts : dameid_file -> scenario;

value first_duration : task_def -> int;

value parse_graph_prec_eoi : Stream.t char -> option (list (list int));
value parse_latency_list_eoi : Stream.t char -> option (list latency_constr);
value parse_user_priority_eoi : Stream.t char -> option (list int);

value parse_and_check_dameid : Stream.t char -> list (Ploc.t * dameid_file);
